#!/usr/bin/perl -w
# ------------------------------------------------------------
# SWAT v2.1
# (S)earch (W)ith (A)uthority (T)ool
#          
# Last updated 12/22/97
# 
# Copyright (c) 1997 Chris Knight <cknite@net66.com>
# http://www.chriscrawler.com/swat
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of 
# the License, or (at your option) any later version.
#
# This pogram is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program, if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# The newest version of SWAT can always be found at
# http://www.chriscrawler.com/swat

my $form;
my $swatparse;
my $config;
my $g;
my $s;

BEGIN {
    use Swatparse;
    use ConfigParse;

    $swatparse = Swatparse->new();
    $form = $swatparse->get_form();

    $form = {
        conf            => 'config',
	sch		=> '<',
	cs		=> 'i',
	st		=> 'perc',
	what		=> 'any',
	'p'		=> 1,
	rpp		=> 1,
	ver		=> 'full',
	res		=> 20,
       	title		=> 10,
       	key		=> 1,
	desc		=> 1,
       	body		=> 5,
    };

    $config = ConfigParse->new($form->{conf});

    $g = $config->get("Global");
    $s = $config->get("Search");

    unshift (@INC, $g->{searchdir});
    unshift (@INC, $g->{extdir});
    unshift (@INC, $g->{dbdir});
    unshift (@INC, $g->{swatdir});
    unshift (@INC, $g->{outdir});
}

use Benchmark;
use strict;

my $t0 = new Benchmark;

use Swatindex;
use Swathtml;
use Swatfile;
use Swatout;
use Entities();

my $counter = ();

my $swathtml = Swathtml->new($g->{template});
$swathtml->return_beginning_html();

my $swatindex = Swatindex->new($g);
$swatindex->openr();

my @files = $swatindex->get_files();
my $files;

my $terms = $swatparse->parse_form($form->{sch},$form->{what});

for (@$terms) {
    my $decoded = Entities::decode($_);
    my ($file, $ext2);
    foreach $file (@files) {
	my $entry = $swatindex->get_entry($file);
	foreach my $ext (keys %$s) {
	    $ext = $s->{$ext}.".pm";
	    require $ext;
	    $ext =~ s/\/|\\/::/g;
	    $ext =~ s/\.pm//;
	    $ext2 = $ext;
	}

	my $swatsearch = $ext2->new($form,$entry,$decoded);
	$counter->{$file} = $swatsearch->non_boolean_search();

	if ($counter->{$file} > 0) {
	    # If it's a result, pack away the description and title to pass along
	    # to the output object Swatout
	    $files->{$file}{desc} = $entry->{desc};
	    $files->{$file}{title} = $entry->{title};
	}
    }
}

my $t1 = new Benchmark;
my $td = timediff($t1, $t0);
my $time = timestr($td);
$time =~ s/(.*?)\(.*\)/$1/;

my $swatout = Swatout->new($g,$form,$files,$counter,$time);
$swatout->return_html();
$swathtml->return_end_html($g->{output});





